<?php class formWidgetWdstatOptions extends cmsForm {

    public function init() {

        $model = cmsCore::getModel('content');
        $ctypes = $model->filterEqual('is_enabled', '1')->get('content_types');

        $ctypes['users']['name'] = 'users';
        $ctypes['users']['title'] = 'Пользователи';

        foreach ($ctypes as $ctype) {

            $c_fields[$ctype['name'].'_on'] = new fieldCheckbox('options:ctype_'.$ctype['name'], array(
                'title' => $ctype['title']
            ));

            $c_newtitle_hint = $ctype['name'] != 'users' ? 'Если оставить пустым, то будет выводиться название типа контента.' : '';

            $c_fields[$ctype['name'].'_newtitle'] = new fieldString('options:newtitle_'.$ctype['name'], array(
                'title' => 'Замена названия',
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                ),
                'hint' => $c_newtitle_hint
            ));

            if ($ctype['name'] == 'users') {

                $c_fields[$ctype['name'].'_labels'] = new fieldString('options:labels_'.$ctype['name'], array(
                    'title' => 'Замена слова "пользователи"',
                    'hint' => 'один|два|много, например <b>человек|человека|человек</b>',
                    'visible_depend' => array(
                        'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                    )
                ));

            } else {

                $c_fields[$ctype['name'].'_hide_text'] = new fieldCheckbox('options:hide_text_'.$ctype['name'], array(
                    'title' => 'Скрыть описание',
                    'visible_depend' => array(
                        'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                    )
                ));

            }

            $c_fields[$ctype['name'].'_bgcolor'] = new fieldColor('options:bgcolor_'.$ctype['name'], array(
                'title' => 'Цвет блока',
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                )
            ));

            $c_fields[$ctype['name'].'_color'] = new fieldColor('options:color_'.$ctype['name'], array(
                'title' => 'Цвет текста',
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                    'options:hide_text_'.$ctype['name'] => array('hide' => array('1')),
                )
            ));

            $c_fields[$ctype['name'].'_tcolor'] = new fieldColor('options:tcolor_'.$ctype['name'], array(
                'title' => 'Цвет текста заголовка',
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                )
            ));

            $c_fields[$ctype['name'].'_ncolor'] = new fieldColor('options:ncolor_'.$ctype['name'], array(
                'title' => 'Цвет числа',
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                )
            ));

            $c_fields[$ctype['name'].'_order'] = new fieldNumber('options:order_'.$ctype['name'], array(
                'title' => 'Порядок',
                'default' => 10,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'visible_depend' => array(
                    'options:ctype_'.$ctype['name'] => array('show' => array('1')),
                )
            ));

        }

        $screens = array('1440', '1200', '1024', '768', '576', '425');

        foreach ($screens as $screen) {

            $a_fields[$screen.'_show'] = new fieldCheckbox('options:a'.$screen.'_show', array(
                'title' => 'Разрешение экрана до '.$screen.'px'
            ));

            $a_fields[$screen.'_p_h'] = new fieldNumber('options:a'.$screen.'_p_h', array(
                'title' => 'Горизонтальный внутренний отступ контейнера',
                'default' => 20,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_p_v'] = new fieldNumber('options:a'.$screen.'_p_v', array(
                'title' => 'Вертикальный внутренний отступ контейнера',
                'default' => 30,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_title_fs'] = new fieldNumber('options:a'.$screen.'_title_fs', array(
                'title' => 'Размер шрифта заголовка',
                'units' => 'px',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_title_m'] = new fieldNumber('options:a'.$screen.'_title_m', array(
                'title' => 'Расстояние между заголовком и текстом',
                'default' => 20,
                'units' => 'px',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_desc_fs'] = new fieldNumber('options:a'.$screen.'_desc_fs', array(
                'title' => 'Размер шрифта текста перед блоком статистики',
                'units' => 'px',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_desc_m'] = new fieldNumber('options:a'.$screen.'_desc_m', array(
                'title' => 'Расстояние между текстом и блоком статистики',
                'default' => 20,
                'units' => 'px',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_row_count'] = new fieldNumber('options:a'.$screen.'_row_count', array(
                'title' => 'Количество блоков в ряду',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_block_margin'] = new fieldNumber('options:a'.$screen.'_block_margin', array(
                'title' => 'Расстояние между блоками',
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_block_height'] = new fieldNumber('options:a'.$screen.'_block_height', array(
                'title' => 'Высота блока',
                'default' => 100,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_tfsize'] = new fieldNumber('options:a'.$screen.'_tfsize', array(
                'title' => 'Размер шрифта заголовка блока',
                'default' => 32,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_tmargin'] = new fieldNumber('options:a'.$screen.'_tmargin', array(
                'title' => 'Расстояние между заголовком и описанием блока',
                'default' => 10,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_dfsize'] = new fieldNumber('options:a'.$screen.'_dfsize', array(
                'title' => 'Размер шрифта описания в блоке',
                'default' => 14,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

            $a_fields[$screen.'_number_width'] = new fieldNumber('options:a'.$screen.'_number_width', array(
                'title' => 'Ширина блока с числом',
                'default' => 100,
                'options' => array(
                    'is_abs' => true,
                    'is_ceil' => true,
                    'save_zero' => true
                ),
                'units' => 'px',
                'visible_depend' => array(
                    'options:a'.$screen.'_show' => array('show' => array('1'))
                )
            ));

        }

        return array(

            array(
                'type' => 'fieldset',
                'title' => 'Заголовок и текст',
                'childs' => array(

                    new fieldCheckbox('options:title_show', array(
                        'title' => 'Заголовок'
                    )),

                    new fieldString('options:title', array(
                        'title' => 'Текст заголовка',
                        'visible_depend' => array(
                            'options:title_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldList('options:title_h', array(
                        'title' => 'Тег заголовка',
                        'default' => 'h1',
                        'items' => array(
                            'h1' => 'h1',
                            'h2' => 'h2',
                            'h3' => 'h3',
                            'h4' => 'h4',
                            'h5' => 'h5',
                            'h6' => 'h6'
                        ),
                        'visible_depend' => array(
                            'options:title_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldColor('options:title_color', array(
                        'title' => 'Цвет шрифта заголовка',
                        'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                        'visible_depend' => array(
                            'options:title_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldNumber('options:title_fs', array(
                        'title' => 'Размер шрифта заголовка',
                        'units' => 'px',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                        'visible_depend' => array(
                            'options:title_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldNumber('options:title_m', array(
                        'title' => 'Расстояние между заголовком и следующим элементом',
                        'default' => 30,
                        'units' => 'px',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'visible_depend' => array(
                            'options:title_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldCheckbox('options:text_show', array(
                        'title' => 'Текст'
                    )),

                    new fieldText('options:desc', array(
                        'title' => 'Текст перед блоком статистики',
                        'visible_depend' => array(
                            'options:text_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldColor('options:desc_color', array(
                        'title' => 'Цвет текста',
                        'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                        'visible_depend' => array(
                            'options:text_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldNumber('options:desc_fs', array(
                        'title' => 'Размер шрифта',
                        'units' => 'px',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'hint' => 'Оставьте поле пустым, если хотите применить стили из вашего шаблона',
                        'visible_depend' => array(
                            'options:text_show' => array('show' => array('1')),
                        )
                    )),

                    new fieldNumber('options:desc_m', array(
                        'title' => 'Расстояние между текстом и блоком статистики',
                        'default' => 50,
                        'units' => 'px',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'visible_depend' => array(
                            'options:text_show' => array('show' => array('1')),
                        )

                    ))

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => 'Данные',
                'childs' => $c_fields
            ),

            array(
                'type' => 'fieldset',
                'title' => 'Контейнер',
                'childs' => array(

                    new fieldList('options:bg', array(
                        'title' => 'Заливка',
                        'default' => 'image',
                        'items' => array(
                            'image' => 'Изображение',
                            'color' => 'Цвет'
                        )
                    )),

                    new fieldColor('options:bgcolor', array(
                        'title' => 'Цвет заливки',
                        'default' => '#ffffff',
                        'visible_depend' => array(
                            'options:bg' => array('show' => array('color')),
                        )
                    )),

                    new fieldImage('options:bgimage', array(
                        'title' => 'Фоновое изображение',
                        'options' => array(
                            'sizes' => array('original')
                        ),
                        'visible_depend' => array(
                            'options:bg' => array('show' => array('image'))
                        )
                    )),

                    new fieldCheckbox('options:parallax', array(
                        'title' => 'Параллакс',
                        'default' => 1,
                        'visible_depend' => array(
                            'options:bg' => array('show' => array('image'))
                        )
                    )),

                    new fieldNumber('options:parallax_delay', array(
                        'title' => 'Скорость анимации',
                        'default' => '0.4',
                        'visible_depend' => array(
                            'options:parallax' => array('show' => array('1')),
                            'options:bg' => array('hide' => array('color')),
                        ),
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => false,
                            'save_zero' => true
                        ),
                        'units' => 'сек',
                        'hint' => 'Разделителем целой и дробной части должна быть точка'
                    )),

                    new fieldList('options:parallax_transition', array(
                        'title' => 'Скорость перехода',
                        'default' => 'ease-out',
                        'items' => array(
                            'ease' => 'ease',
                            'linear' => 'linear',
                            'ease-in' => 'ease-in',
                            'ease-out' => 'ease-out',
                            'ease-in-out' => 'ease-in-out'
                        ),
                        'visible_depend' => array(
                            'options:parallax' => array('show' => array('1')),
                            'options:bg' => array('hide' => array('color')),
                        )
                    )),

                    new fieldList('options:parallax_orientation', array(
                        'title' => 'Направление анимации',
                        'default' => 'up',
                        'items' => array(
                            'left' => 'Влево',
                            'right' => 'Вправо',
                            'up' => 'Вверх',
                            'down' => 'Вниз',
                            'up-left' => 'Вверх влево',
                            'up-right' => 'Вверх вправо',
                            'down-left' => 'Вниз влево',
                            'down-right' => 'Вниз вправо'
                        ),
                        'visible_depend' => array(
                            'options:parallax' => array('show' => array('1')),
                            'options:bg' => array('hide' => array('color')),
                        )
                    )),

                    new fieldCheckbox('options:overlay', array(
                        'title' => 'Оверлей (затемнение/осветление)',
                        'default' => 1,
                        'visible_depend' => array(
                            'options:bg' => array('show' => array('image'))
                        )
                    )),

                    new fieldColor('options:overlay_color', array(
                        'title' => 'Цвет наложения',
                        'default' => '#ffffff',
                        'visible_depend' => array(
                            'options:overlay' => array('show' => array('1')),
                            'options:bg' => array('hide' => array('color')),
                        )
                    )),

                    new fieldNumber('options:overlay_opacity', array(
                        'title' => 'Прозрачность',
                        'default' => 10,
                        'visible_depend' => array(
                            'options:overlay' => array('show' => array('1')),
                            'options:bg' => array('hide' => array('color')),
                        ),
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => '%'
                    )),

                    new fieldNumber('options:p_h', array(
                        'title' => 'Горизонтальный внутренний отступ',
                        'default' => 30,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:p_v', array(
                        'title' => 'Вертикальный внутренний отступ',
                        'default' => 80,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => 'Блоки статистики',
                'childs' => array(

                    new fieldNumber('options:row_count', array(
                        'title' => 'Количество блоков в ряду',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        )
                    )),

                    new fieldNumber('options:block_margin', array(
                        'title' => 'Расстояние между блоками',
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:block_height', array(
                        'title' => 'Высота блока',
                        'default' => 100,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:block_opacity', array(
                        'title' => 'Прозрачность блока',
                        'default' => 20,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => '%'
                    )),

                    new fieldList('options:block_title_h', array(
                        'title' => 'Тег заголовка блока',
                        'default' => 'h2',
                        'items' => array(
                            'h2' => 'h2',
                            'h3' => 'h3',
                            'h4' => 'h4',
                            'h5' => 'h5',
                            'h6' => 'h6'
                        )
                    )),

                    new fieldNumber('options:tfsize', array(
                        'title' => 'Размер шрифта заголовка блока',
                        'default' => 32,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:tmargin', array(
                        'title' => 'Расстояние между заголовком и описанием',
                        'default' => 10,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:dfsize', array(
                        'title' => 'Размер шрифта описания',
                        'default' => 14,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                    new fieldNumber('options:number_width', array(
                        'title' => 'Ширина блока с числом',
                        'default' => 100,
                        'options' => array(
                            'is_abs' => true,
                            'is_ceil' => true,
                            'save_zero' => true
                        ),
                        'units' => 'px'
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => 'Адаптивность',
                'childs' => $a_fields
            ),

            array(
                'type' => 'fieldset',
                'title' => 'Свои стили',
                'childs' => array(

                    new fieldString('options:file_css', array(
                        'title' => 'Подключить свой файл стилей',
                        'hint' => 'Например, <b>templates/default/css/custom.css</b>'
                    )),

                    new fieldHtml('options:add_css', array(
                        'title' => 'Добавить свои стили в HEAD',
                        'options' => array(
                            'editor' => 'ace'
                        )
                    ))

                )

            )

        );

    }

}
