<?php class widgetWdstat extends cmsWidget {

    public $is_cacheable = false;

    public function run(){

        $this->setWrapper('wrapper_plain');

        $ver = str_replace('.', '', cmsCore::getVersion());
        $data['id'] = $ver >= 2111 ? $this->bind_id : $this->id;

        $config = cmsConfig::getInstance();

        $bg = $this->getOption('bg', 'image');
        $bgimage = $this->getOption('bgimage');
        $parallax = $this->getOption('parallax');
        $bgcolor = $this->getOption('bgcolor');
        $p_v = $this->getOption('p_v') && $this->getOption('p_v') > 0 ? $this->getOption('p_v').'px' : 0;
        $p_h = $this->getOption('p_h') && $this->getOption('p_h') > 0 ? $this->getOption('p_h').'px' : 0;
        $padding = $p_v == 0 && $p_h  == 0 ? '' : 'padding:'.$p_v.' '.$p_h.';';
        $data['bg_class'] = '';
        $bg_style = $padding;
        $data['overlay'] = '';
        $data['parallax'] = '';

        if ($bg == 'image' && $bgimage) {

            $data['bg_class'] = ' wdstat_bgimg';
            $bg_img = 'background-image:url(\''.$config->upload_root.html_image_src($bgimage, 'original').'\');';

            if ($parallax == 1) {

                $bg_img = '';
                $script = '';
                $script .= '<script>$(document).ready(function(){var image = document.getElementsByClassName(\'parallax_img_'.$data['id'].'\');new simpleParallax(image, {';

                $script .= 'delay: '.($this->getOption('parallax_delay') && $this->getOption('parallax_delay') > 0 ? $this->getOption('parallax_delay') : '0.4').',';
                $script .= 'transition: "'.$this->getOption('parallax_transition').'",';
                $script .= 'orientation: "'.str_replace('-', ' ', $this->getOption('parallax_orientation')).'"';

                $script .= '});});</script>';

                cmsTemplate::getInstance()->addBottom($script);

                $data['parallax'] = '<img src="'.$config->upload_root.html_image_src($bgimage, 'original').'" alt="заголовок" class="parallax_img_'.$data['id'].'">';

            }

            $bg_style = $padding.$bg_img;
            $data['overlay'] = $this->getOption('overlay');

            if ($data['overlay'] == 1) {

                $overlay_color = $this->getOption('overlay_color') ? $this->getOption('overlay_color') : '#ffffff';
                $overlay_opacity = $this->getOption('overlay_opacity') ? $this->getOption('overlay_opacity') : 10;
                $overlay_rgb = $this->rgba($overlay_color, $overlay_opacity);
                $data['bg_overlay'] = 'style="background:'.$overlay_rgb.';"';

            }

        }

        if ($bg == 'color' && $bgcolor) $bg_style = $padding.'background:'.$bgcolor.';';

        $data['title'] = '';
        $title_styles = '';

        if ($this->getOption('title_show') && $this->getOption('title')) {

            $title_color = $this->getOption('title_color') ? 'color:'.$this->getOption('title_color').';' : '';
            $title_fs = $this->getOption('title_fs') && $this->getOption('title_fs') > 0 ? 'font-size:'.$this->getOption('title_fs').'px;' : '';
            $title_m = $this->getOption('title_m') && $this->getOption('title_m') > 0 ? 'margin-bottom:'.$this->getOption('title_m').'px;' : '';
            $title_styles = $title_color || $title_fs || $title_m ? $title_color.$title_fs.$title_m : '';
            $data['title'] = '<'.$this->getOption('title_h').' class="wdstat_title">'.$this->getOption('title').'</'.$this->getOption('title_h').'>';

        }

        $data['desc'] = '';
        $desc_styles = '';

        if ($this->getOption('text_show') && $this->getOption('desc')) {

            $desc_color = $this->getOption('desc_color') ? 'color:'.$this->getOption('desc_color').';' : '';
            $desc_fs = $this->getOption('desc_fs') ? 'font-size:'.$this->getOption('desc_fs').'px;' : '';
            $desc_m = $this->getOption('desc_m') && $this->getOption('desc_m') > 0 ? 'margin-bottom:'.$this->getOption('desc_m').'px;' : '';
            $desc_styles = $desc_color || $desc_fs ? $desc_color.$desc_fs.$desc_m : '';
            $data['desc'] = '<p class="wdstat_desc">'.$this->getOption('desc').'</p>';

        }

        $model = cmsCore::getModel('content');

        $ctypes_list = $model->filterEqual('is_enabled', '1')->get('content_types');
        $data['ctypes'] = array();
        $block_opacity = $this->getOption('block_opacity');
        $number_width = $this->getOption('number_width') && $this->getOption('number_width') > 0 ? $this->getOption('number_width') : 100;

        if ($this->getOption('ctype_users')) {

            $ctypes_list['users'] = [

                'name' => 'users',
                'title' => 'Пользователи'

            ];
        }

        foreach ($ctypes_list as $ctype) {

            if (!isset($this->options['ctype_'.$ctype['name']]) || $this->getOption('ctype_'.$ctype['name']) != 1) continue;

            $count = $ctype['name'] != 'users' ? $model->getCount('con_'.$ctype['name']) : $model->filterIsNull('is_deleted')->filterIsNull('is_locked')->getCount($ctype['name']);

            if ($count == 0) continue;

            if ($ctype['name'] != 'users') {

                $labels =  $model->yamlToArray($ctype['labels']);

            } else {

                $labels = ['one' => 'пользователь', 'two' => 'пользователя', 'many' => 'пользователей'];

                if (!empty($this->getOption('labels_'.$ctype['name']))) {

                    $labels_arr = explode('|', $this->getOption('labels_'.$ctype['name']));

                    $labels = count($labels_arr) == 3 ? ['one' => $labels_arr[0], 'two' => $labels_arr[1], 'many' => $labels_arr[2]] : $labels;

                }

            }

            $options = $ctype['name'] != 'users' ? $model->yamlToArray($ctype['options']) : ['list_on' => 1];
            $labels = implode('|', array($labels['one'], $labels['two'], $labels['many']));
            $ctype_bgcolor = $this->getOption('bgcolor_'.$ctype['name']) ? $this->getOption('bgcolor_'.$ctype['name']) : '';

            if ($block_opacity && $block_opacity > 0 && $ctype_bgcolor) $ctype_bgcolor = $this->rgba($ctype_bgcolor, $block_opacity);

            $ctype_bg = $ctype_bgcolor ? 'background:'.$ctype_bgcolor.';' : '';
            $ctype_hide_text = $ctype['name'] != 'users' ? $this->getOption('hide_text_'.$ctype['name']) : 1;
            $ctype_color = $this->getOption('color_'.$ctype['name']) ? 'color:'.$this->getOption('color_'.$ctype['name']).';' : '';
            $ctype_tcolor = $this->getOption('tcolor_'.$ctype['name']) ? 'color:'.$this->getOption('tcolor_'.$ctype['name']).';' : $ctype_color;
            $ctype_styles = $ctype_bg || $ctype_color ? ' style="'.$ctype_bg.$ctype_color.'"' : '';
            $ctype_tstyles = $ctype_tcolor ? ' style="'.$ctype_tcolor.'"' : '';
            $ncolor = $this->getOption('ncolor_'.$ctype['name']) ? ' style="color:'.$this->getOption('ncolor_'.$ctype['name']).';"' : '';
            $newtitle = $this->getOption('newtitle_'.$ctype['name']);

            $data['ctypes'][] = array(
                'name' => $ctype['name'],
                'title' => $newtitle ? $newtitle : $ctype['title'],
                'desc' => !$ctype_hide_text ? $ctype['description'] : '',
                'count' => '<div class="wdstat_number_block"><div class="wdstat_number wdstat_number_'.$data['id'].'_'.$ctype['name'].'"'.$ncolor.'>'.$count.'</div></div><div class="wdstat_counter">'.str_replace($count.' ', '', html_spellcount_only($count, $labels)).'</div>',
                'styles' => $ctype_styles,
                'tstyles' => $ctype_tstyles,
                'order' => $this->getOption('order_'.$ctype['name']) && $this->getOption('order_'.$ctype['name']) > 0 ? $this->getOption('order_'.$ctype['name']) : 10,
                'in_list' => $options['list_on'] == 1 ? 1 : ''
            );

        }

        if (!$data['ctypes'] && !$data['title'] && !$data['desc']) return false;

        $row_count = $this->getOption('row_count') && $this->getOption('row_count') > 0 ? $this->getOption('row_count') : 1;
        $block_margin = $this->getOption('block_margin') && $this->getOption('block_margin') > 0 ? $this->getOption('block_margin') : 0;
        $block_width = 100 / $row_count;
        $block_style = 'width:'.$block_width.'%;';
        $t_p = '';

        if ($block_margin > 0 && $row_count > 1) {

            $block_style = 'width:calc('.$block_width.'% - '.$block_margin.'px);margin-right:'.$block_margin.'px;';

            if ($this->getOption('p_h') >= $block_margin) {

                $bg_style = $bg_style.'padding-right:'.($this->getOption('p_h') - $block_margin).'px;';
                $t_p = 'padding-right:'.$block_margin.'px;';

            }

            if ($this->getOption('p_v') >= $block_margin) $bg_style = $bg_style.'padding-bottom:'.($this->getOption('p_v') - $block_margin).'px;';

        }

        if ($block_margin > 0 && $row_count == 1 && $this->getOption('p_v') >= $block_margin) $bg_style = $bg_style.'padding-bottom:'.($this->getOption('p_v') - $block_margin).'px;';

        $block_height = $this->getOption('block_height') && $this->getOption('block_height') > 0 ? $this->getOption('block_height') : 100;
        $custom_styles = $this->getOption('add_css') ? $this->getOption('add_css') : '';
        $data['bth'] = $this->getOption('block_title_h');
        $tfsize = $this->getOption('tfsize') && $this->getOption('tfsize') > 0 ? 'font-size:'.$this->getOption('tfsize').'px;' : '';
        $tmargin = $this->getOption('tmargin') && $this->getOption('tmargin') > 0 ? 'margin-bottom:'.$this->getOption('tmargin').'px;' : '';
        $tstyles = $tfsize || $tmargin ? '#wdstat_'.$data['id'].' .wdstat_item '.$data['bth'].'{'.$tfsize.$tmargin.'}' : '';
        $dfsize = $this->getOption('dfsize') && $this->getOption('dfsize') > 0 ? 'font-size:'.$this->getOption('dfsize').'px;' : '';

        $all_styles = '';

        $all_styles .= '<style>';
        $all_styles .= '#wdstat_'.$data['id'].'{'.$bg_style.'}';
        $all_styles .= $desc_styles ? '#wdstat_'.$data['id'].' .wdstat_desc{'.$desc_styles.$t_p.'}' : '';
        $all_styles .= $title_styles ? '#wdstat_'.$data['id'].' .wdstat_title{'.$title_styles.$t_p.'}' : '';
        $all_styles .= '#wdstat_'.$data['id'].' .wdstat_item{'.$dfsize.$block_style.'margin-bottom:'.$block_margin.'px;'.($row_count == 1 ? 'min-' : '').'height:'.$block_height.'px;}';
        $all_styles .= '#wdstat_'.$data['id'].' .wdstat_count{width:'.$number_width.'px;}';
        $all_styles .= '#wdstat_'.$data['id'].' .wdstat_ctype{width:calc(100% - '.$number_width.'px);margin-left:'.$number_width.'px;}';
        $all_styles .= '#wdstat_'.$data['id'].' .wdstat_ctype.wdstat_notdesc{min-height:'.($block_height - 40).'px;}';
        $all_styles .= $tstyles;

        $screens = array('1440', '1200', '1024', '768', '576', '425');
        $gen_styles = array();
        $a_screens = array();

        foreach ($screens as $screen) {

            if ($this->getOption('a'.$screen.'_show')) {

                $a_screen = array(
                    'p_h' => $this->getOption('a'.$screen.'_p_h'),
                    'p_v' => $this->getOption('a'.$screen.'_p_v'),
                    'title_fs' => $data['title'] ? ($this->getOption('a'.$screen.'_title_fs') && $this->getOption('a'.$screen.'_title_fs') > 0 ? $this->getOption('a'.$screen.'_title_fs') : '') : '',
                    'title_m' => $data['title'] ?$this->getOption('a'.$screen.'_title_m') : '',
                    'desc_fs' => $data['desc'] ? ($this->getOption('a'.$screen.'_desc_fs') && $this->getOption('a'.$screen.'_desc_fs') > 0 ? $this->getOption('a'.$screen.'_desc_fs') : '') : '',
                    'desc_m' => $data['desc'] ? $this->getOption('a'.$screen.'_desc_m') : '',
                    'row_count' => $this->getOption('a'.$screen.'_row_count') && $this->getOption('a'.$screen.'_row_count') > 1 ? $this->getOption('a'.$screen.'_row_count') : 1,
                    'block_margin' => $this->getOption('a'.$screen.'_block_margin'),

                    'block_height' => $this->getOption('a'.$screen.'_block_height'),
                    'tfsize' => $this->getOption('a'.$screen.'_tfsize') && $this->getOption('a'.$screen.'_tfsize') > 0 ? $this->getOption('a'.$screen.'_tfsize') : '',
                    'tmargin' => $this->getOption('a'.$screen.'_tmargin') && $this->getOption('a'.$screen.'_tmargin') > 0 ? $this->getOption('a'.$screen.'_tmargin') : '',
                    'dfsize' => $this->getOption('a'.$screen.'_dfsize') && $this->getOption('a'.$screen.'_dfsize') > 0 ? $this->getOption('a'.$screen.'_dfsize') : '',
                    'number_width' => $this->getOption('a'.$screen.'_number_width') && $this->getOption('a'.$screen.'_number_width') > 0 ? $this->getOption('a'.$screen.'_number_width') : ''

                );

                $a_screens[$screen] = array_diff($a_screen, array(''));

            }

        }

        $a_screens_st = array();

        if ($a_screens) {

            foreach ($a_screens as $screen => $a_scr) {

                $a_screen_st = array();

                foreach ($a_scr as $key => $a_screen_i) {

                    $new_key_2 = '';
                    $new_style_2 = '';
                    $new_style_3 = '';
                    $new_key_4 = '';
                    $new_style_4 = '';

                    $new_p_v = $this->getOption('a'.$screen.'_p_v');
                    $new_p_h = $this->getOption('a'.$screen.'_p_h');

                    if ($key == 'p_h' || $key == 'p_v') {

                        $new_key = '#wdstat_'.$data['id'];
                        $new_style = 'padding:'.($new_p_v > 0 ? $new_p_v.'px' : '0').' '.($new_p_h > 0 ? $new_p_h.'px' : '0').';';

                    }

                    if ($key == 'title_fs' || $key == 'title_m')$new_key = '#wdstat_'.$data['id'].' .wdstat_title';
                    if ($key == 'desc_fs' || $key == 'desc_m') $new_key = '#wdstat_'.$data['id'].' .wdstat_desc';
                    if ($key == 'row_count' || $key == 'block_margin' || $key == 'block_height' || $key == 'dfsize') $new_key = '#wdstat_'.$data['id'].' .wdstat_item';

                    if ($key == 'title_fs' || $key == 'desc_fs') $new_style = 'font-size:'.$a_screen_i.'px;';
                    if ($key == 'title_m' || $key == 'desc_m') $new_style = 'margin-bottom:'.$a_screen_i.'px;';

                    if ($key == 'row_count') {

                        $new_width = 100 / $a_screen_i;
                        $new_style = 'width:'.$new_width.'%;margin-bottom:'.($block_margin > 0 ? $block_margin.'px' : '0').';';
                        $block_margin = $this->getOption('a'.$screen.'_block_margin');
                        if ($block_margin > 0 && $a_screen_i > 1) {

                            $new_style = 'width:calc('.$new_width.'% - '.$block_margin.'px);margin-right:'.($block_margin > 0 ? $block_margin.'px' : 0).';';

                            if ($new_p_h >= $block_margin) {

                                $new_key_2 = '#wdstat_'.$data['id'];
                                $new_style_2 = 'padding-right:'.($new_p_h - $block_margin).'px;';
                                $new_key_4 = '#wdstat_'.$data['id'].' .wdstat_desc, #wdstat_'.$data['id'].' .wdstat_title';
                                $new_style_4 = 'padding-right:'.$block_margin.'px;';

                            }

                            if ($new_p_v >= $block_margin) {

                                $new_key_2 = '#wdstat_'.$data['id'];
                                $new_style_3 = 'padding-bottom:'.($new_p_v - $block_margin).'px;';

                            }

                        } else {

                            if ($new_p_v >= $block_margin) {

                                $new_key_2 = '#wdstat_'.$data['id'];
                                $new_style_3 = 'padding-bottom:'.($new_p_v - $block_margin).'px;padding-right:'.$new_p_h.'px;';
                                $new_key_4 = '#wdstat_'.$data['id'].' .wdstat_desc, #wdstat_'.$data['id'].' .wdstat_title';
                                $new_style_4 = 'padding-right:0;';

                            }

                        }

                    }

                    if ($key == 'block_height' && $a_screen_i) {

                        $r_count = $this->getOption('a'.$screen.'_row_count') && $this->getOption('a'.$screen.'_row_count') > 0 ? $this->getOption('a'.$screen.'_row_count') : 1;
                        $new_style = ($r_count == 1 ? 'height:auto;min-' : '').'height:'.$a_screen_i.'px;';

                    }

                    if (($key == 'tfsize' || $key == 'tmargin') && $a_screen_i) $new_key = '#wdstat_'.$data['id'].' .wdstat_item '.$data['bth'];

                    if ($key == 'tfsize' && $a_screen_i) $new_style = 'font-size:'.$a_screen_i.'px;';

                    if ($key == 'tmargin' && $a_screen_i) $new_style = 'margin-bottom:'.$a_screen_i.'px;';

                    if ($key == 'dfsize' && $a_screen_i) $new_style = 'font-size:'.$a_screen_i.'px;';

                    if ($key == 'number_width' && $a_screen_i) {

                        $new_key = '#wdstat_'.$data['id'].' .wdstat_count';
                        $new_style = 'width:'.$a_screen_i.'px;';

                        $new_key_4 .= '#wdstat_'.$data['id'].' .wdstat_ctype';
                        $new_style_4 .= 'width:calc(100% - '.$a_screen_i.'px);margin-left:'.$a_screen_i.'px;';

                    }

                    $a_screen_st[$new_key][] = $new_style;
                    $a_screen_st[$new_key] = array_unique($a_screen_st[$new_key]);

                    $a_screen_st_2[$new_key_2] = array($new_style_2, $new_style_3);
                    $a_screen_st_4[$new_key_4] = array($new_style_4);


                }

                $a_screens_st[$screen] = array_merge_recursive($a_screen_st, $a_screen_st_2, $a_screen_st_4);

            }

        }

        if ($a_screens_st) {

            foreach ($a_screens_st as $key => $a_screen_r) {

                foreach ($a_screen_r as $selector => $selector_st) {

                    if (empty($selector) || empty($selector_st)) continue;

                    $result_styles[$key][] = $selector.'{'.implode('', $selector_st).'}';

                }

                $gen_styles[$key] = '@media (max-width: '.$key.'px){'.implode('', $result_styles[$key]).'}';

            }

        }

        $all_styles .= $gen_styles ? implode('', $gen_styles) : '';
        $all_styles .= $custom_styles;
        $all_styles .= '</style>';

        cmsTemplate::getInstance()->addHead($all_styles);

        array_multisort(array_column($data['ctypes'], 'order'), SORT_ASC, $data['ctypes']);

        $data['css'] = $this->getOption('file_css');

        return array(
            'data' => $data,
        );

    }

    public function rgba($bg_color = false, $bg_opaticy = false) {

        if($bg_color) {

            $rgb = substr($bg_color, 1);
            $arr = str_split($rgb, 2);

            foreach($arr as $key => $value) $arr[$key] = hexdec($value);

            $opacity = $bg_opaticy ? ((100 - $bg_opaticy)) / 100 : 1;
            $opacity = number_format((float)$opacity, 2, '.', '');
            $rgba_bg = 'rgba('.$arr[0].','.$arr[1].','.$arr[2].','.$opacity.')';

        } else {

            $rgba_bg = false;

        }

        return $rgba_bg;

    }

}